#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#include "mystruct.h"

int read_structure(int fd, int offset, VALUES *v)
{
  int ret;
  // Move offset
  ret = lseek(fd, offset, SEEK_SET);
  if(ret == -1) {
    return ret;
  }

  // Read the record
  ret = read(fd, v, sizeof(*v));
  if(ret < 0) {
      perror("read");
      exit(-1);
  }
  return ret;
}

int main(int argc, char** argv)
{
  VALUES v;

  // Open for write and create.  R/W by user only
  int fd = open("myfile.out", O_RDONLY);

  if(fd == -1) {
    perror("Unable to open file");
    exit(-1);
  };

  // Successfully opened file

  // Read record
  if(read_structure(fd, sizeof(VALUES), &v) != sizeof(VALUES)) {
    perror("read_structure");
    exit(-1);
  }
  // Print record
  printf("Got: %d %f %s %d\n", v.a, v.b, v.c, v.d);


  
  // Read record
  if(read_structure(fd, 0, &v) != sizeof(VALUES)) {
    perror("read_structure");
    exit(-1);
  }
  // Print record
  printf("Got: %d %f %s %d\n", v.a, v.b, v.c, v.d);



  
  // Close the file
  if(close(fd) != 0) {
    perror("Close error");
    exit(-1);
  }

  return(0);

}
